unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Grids,
  StdCtrls, ExtCtrls, Menus;

type

  { TForm1 }

  TForm1 = class(TForm)
    Testeditfeld: TEdit;
    ListBox: TListBox;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    SG: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure ListBoxClick(Sender: TObject);
    procedure SGClick(Sender: TObject);
    procedure SGKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SGKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    procedure ZeigeListBox(Str:String; ARow:Integer);
    procedure SGCellExit(Sender: TObject);
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  Vorlage: TStringList;
  AltRow, AltCol: Integer;
  AltStr: String;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.SGCellExit(Sender: TObject);
begin
  ListBox.Hide;
end;

procedure TForm1.ZeigeListBox(Str:String; ARow:Integer);
var
  i: Integer;
  Rec: TRect;
  p1, p2:TPoint;
begin
  ListBox.Items.Clear;
  for i:=0 to Vorlage.Count-1 do
    if (length(Str)=0) or (pos(lowercase(Str), lowercase(Vorlage.Strings[i]))>0) then
      ListBox.Items.Add(Vorlage.Strings[i]);

  if ListBox.Items.Count>0 then begin

    Listbox.Parent:=SG;
    Rec:=SG.CellRect(SG.Col, SG.Row);

    inc(Rec.Top, SG.RowHeights[SG.Row]);
    inc(Rec.Bottom, SG.RowHeights[SG.Row]);

    ListBox.BoundsRect:=Rec;
    if ListBox.Items.Count>9 then ListBox.Height:=ListBox.ItemHeight*10
                             else ListBox.Height:=ListBox.ItemHeight*(ListBox.Items.Count+1);

    if Listbox.Height+Rec.Bottom>clientheight then begin
      Rec.Top:=Rec.Top - 2 * SG.RowHeights[SG.Row] - ListBox.Height;
      Rec.Bottom:=Rec.Bottom - 2 * SG.RowHeights[SG.Row];
      ListBox.BoundsRect:=Rec;
    end;

    ListBox.ItemIndex:=-1;
    ListBox.Show;

    Self.ActiveControl.OnExit:=@SGCellExit;

  end else ListBox.Hide;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i, j: Integer;
  SL1, SL2: TStringList;
  Str:string;
begin
  SG.ColWidths[1]:=200;
  SG.ColWidths[2]:=200;

  Vorlage:=TStringList.Create;
  SL1:=TStringList.Create;
  SL2:=TStringList.Create;

  SL1.LoadFromFile('Text.txt');

  SL2.Delimiter:=' ';
  for i:=0 to SL1.Count-1 do begin
    SL2.DelimitedText:=SL1.Strings[i];
    Vorlage.AddStrings(SL2);
  end;

  SL2.Free;
  SL1.Free;

  i:=0;
  while i<Vorlage.Count do begin
    for j:=Vorlage.Count-1 downto i+1 do
      if Vorlage.Strings[i]=Vorlage.Strings[j] then Vorlage.Delete(j);
    inc(i);
  end;

  for i:=0 to Vorlage.Count-1 do begin

    Str:=AnsiToUTF8(Vorlage.Strings[i]);
    Str:=Vorlage.Strings[i];

    for j:=length(Str) downto 1 do

      case Str[j] of
        'a'..'z', 'A'..'Z', #228, #252, #220, #196, #246, #214, #223:;
        else
//          showmessage(Str+' - '+inttostr(Ord(Str[j])));
          delete(Str,j,1);
      end;

    Vorlage.Strings[i]:=Str;

  end;

  i:=0;
  while i<Vorlage.Count do begin
    for j:=Vorlage.Count-1 downto i+1 do
      if (Vorlage.Strings[i]=Vorlage.Strings[j]) or
        (Vorlage.Strings[j]='') then Vorlage.Delete(j);
    inc(i);
  end;

  SG.RowCount:=Vorlage.Count+1;
  for i:=0 to Vorlage.Count-1 do begin
    SG.Cells[0,i+1]:=IntToStr(i);
    Vorlage.Strings[i]:=AnsiToUTF8(Vorlage.Strings[i]);
    SG.Cells[2,i+1]:=Vorlage.Strings[i];
  end;

end;

procedure TForm1.ListBoxClick(Sender: TObject);
var
  Stelle: integer;
begin
  Stelle := ListBox.ItemAtPos((Sender as TListBox).ScreenToClient(Mouse.CursorPos), True);
  SG.Cells[SG.Col, SG.Row]:=ListBox.Items[Stelle];
  SG.Editor:=nil;
end;

procedure TForm1.SGClick(Sender: TObject);
begin
  if (AltRow=SG.Row) and (AltCol=SG.Col) then
    ZeigeListBox(SG.Cells[SG.Col, SG.Row], SG.Row);
  AltRow:=SG.Row;
  AltCol:=SG.Col;
  AltStr:=SG.Cells[SG.Col, SG.Row];
end;

procedure TForm1.SGKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  AltCol:=(Sender as TStringGrid).Col;
  AltRow:=(Sender as TStringGrid).Row;

  if ListBox.Visible then case key of
    40:begin  //Pfeil runter
         if ListBox.ItemIndex<ListBox.Items.Count-1 then ListBox.ItemIndex:=ListBox.ItemIndex+1;
         key:=0;
       end;
    38:begin  //Pfeil hoch
         if ListBox.ItemIndex>0 then ListBox.ItemIndex:=ListBox.ItemIndex-1;
//                                else ListBox.Visible:=false;
         key:=0;
       end;
    13:begin  //Enter
         SG.Cells[SG.Col,SG.Row]:=ListBox.Items[ListBox.ItemIndex];
         ListBox.Visible:=false;
       end;
    34:begin  //Bild runter
         if ListBox.ItemIndex<ListBox.Items.Count-1 then ListBox.ItemIndex:=ListBox.ItemIndex+10
                                                    else ListBox.ItemIndex:=ListBox.Items.Count-1;
         key:=0;
       end;
    33:begin  //Bild hoch
         if ListBox.ItemIndex>10 then ListBox.ItemIndex:=ListBox.ItemIndex-10
                                 else ListBox.ItemIndex:=0;
         key:=0;
       end;
    27:Listbox.Hide;
  end else AltStr:=SG.Cells[SG.Col, SG.Row];

//  Caption:=inttostr(key);
end;

procedure TForm1.SGKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (SG.Col=1) and (AltCol=SG.Col) and (AltRow=SG.Row) then begin
    if SG.Cells[SG.Col, SG.Row] <> altStr then
      ZeigeListBox(SG.Cells[SG.Col, SG.Row], SG.Row);
    altStr:=SG.Cells[SG.Col, SG.Row];
  end;
end;

end.

